/****************************************************************************
**
** Copyright (C) 2004-2010 NIISI RAS. All rights reserved.
**
** This file is part of the KuMir.
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include "customwindow.h"


#include <iostream>
#include "plugin_interface.h"
#include <QtCore>
#include <QtGui>
#ifndef WIN32
#include "unistd.h"
#endif

#include "starter.h"

int main(int argc, char *argv[])
{
      Q_INIT_RESOURCE(application);
      QApplication app(argc, argv);
      app.setQuitOnLastWindowClosed(true);
	QString fileName;
	QString port="";
      if(argc>1)
	{
	//std::cout<<"argc"<<argc<<" argv "<<argv[1]<<"|\n";
	QString param=QString(argv[1]);
	 if(param=="-h")
		{
		std::cout<<"Kumir Plugin starter\n";
		std::cout<<"usage:./pluginstarter [KumPluginFile]\n";
		return 0;
		};
	fileName=param;
	
		if(argc>2)
			{
			port=QString(argv[2]);
			}
	};
	QString modulesInfoPath = QApplication::applicationDirPath();
	qDebug()<<modulesInfoPath+'/'+fileName;
       QPluginLoader loader(modulesInfoPath+'/'+fileName);

	if (kumirPluginInterface  *interface =
                    qobject_cast<kumirPluginInterface  *>(loader.instance()))
		{
		std::cout<<interface->name().toLocal8Bit ().data()<<"\n";

		interface->start();
		QWidget *pult = interface->pultWidget();
		QWidget *module = interface->mainWidget();
		bool resX = module->property("resizableX").toBool();
		bool resY = module->property("resizableY").toBool();
		QString name = interface->name();
		CustomWindow *moduleWindow = new CustomWindow(module, name, resX, resY);
		moduleWindow->setWindowIcon(QIcon(":/module_window.png"));
		CustomWindow *pultWindow = new CustomWindow(pult, name + QString::fromUtf8(" - Пульт"), false, false);
		pultWindow->setWindowIcon(QIcon(":/pult_window.png"));
		Starter *s = new Starter(name, moduleWindow, pultWindow);
		moduleWindow->show();
		pultWindow->show();
//		interface->showPult();
//		interface->showField();
//		interface->showOpt();
		QList<QVariant> args;
		interface->runAlg("|open port", args << QVariant(port));
		std::cout<<"OK\n";
		return app.exec();
		}else
		{
		std::cout<<loader.errorString().toLocal8Bit ().data()<<"\n";
		return -1;
		};

      qDebug("-h for help");
      return 0;
}

