#include "starter.h"
#include "customwindow.h"

Starter::Starter(const QString &name, CustomWindow *mainWindow, CustomWindow *pultWindow) :
    QObject(0)
{
    m_mainWindow = mainWindow;
    m_pultWindow = pultWindow;
    s_name = name;
    connect (mainWindow, SIGNAL(closed()), this, SLOT(handleOneWindowClosed()));
    connect (pultWindow, SIGNAL(closed()), this, SLOT(handleOneWindowClosed()));
    QSettings settings("NIISI RAS", "KumPluginStarter");
    mainWindow->restoreGeometry(settings.value(name+"/MainWindowGeometry","").toByteArray());
    pultWindow->restoreGeometry(settings.value(name+"/PultWindowGeometry","").toByteArray());
}

void Starter::handleOneWindowClosed()
{
    QSettings settings("NIISI RAS", "KumPluginStarter");
    settings.setValue(s_name+"/MainWindowGeometry",m_mainWindow->saveGeometry());
    settings.setValue(s_name+"/PultWindowGeometry",m_pultWindow->saveGeometry());
    qApp->exit();
}


